/******************************************************************************
 *   INIMIGO.CPP                                                               *
 ******************************************************************************		
 *                                                                            *
 *    Arquivo contendo as definies da classe CInimigo, que  derivada       *
 * de CPersonagem.                                                            *
 *                                                                            *
 ******************************************************************************
 *                                                                            * 
 *    Trabalho Prtico de Automao em Tempo Real                             *
 *       6 Perodo de Engenharia de Controle e Automao                     *
 *           Universidade Federal de Minas Gerais                             *
 *                                                                            *
 *    Prof.:  Constantino Seixas Filho                                        *
 *                                                                            *
 *    Alunos: Rafael Cervolo                                                 *
 *            Thiago Barbosa                                                  *
 *                                                                            *
 *****************************************************************************/

#include "classes.h"
//---------------------------------------------------------------------------//
void CInimigo::Vagueia()
// IMPORTANTE: Esta  a funo multi-thread da classe CInimigo
{
CJogador *p;  
char atual,proximo; //Valores de casas do labirinto
TSentido VecSent[3];
int NSent;
srand(clock()); //Randomize
SentidoAtual = sCima; // Valor inicial qualquer
TStatus StatusDoJogador;
while (Status != sMorto)
{
	NSent=0;
	// Espera-se pelo sinal do evento para fazer o movimento.
	WaitForSingleObject(hEvento,TempoDeEspera);
	// Inicialmente, o inimigo decide para onde ir
	// Esta decisao no precisa ser na seo crtica, pois para o inimigo,
	// apenas interessa se tm parede ou no no local, sendo que esta no se
	// modifica durante uma mesma partida
	atual = pLabirinto->GetPosicao(Posicao);
	switch (SentidoAtual)
	{
	case sDireita:
		proximo = pLabirinto->GetPosicao(POS(Posicao.x+1,Posicao.y));
		break;
	case sEsquerda:
		proximo = pLabirinto->GetPosicao(POS(Posicao.x-1,Posicao.y));
		break;
	case sCima:
		proximo = pLabirinto->GetPosicao(POS(Posicao.x,Posicao.y-1));
		break;
	case sBaixo:
		proximo = pLabirinto->GetPosicao(POS(Posicao.x,Posicao.y+1));
		break;
	}
	if (pLabirinto->GetPosicao(POS(Posicao.x+1,Posicao.y))!=PAREDE)
	{
		VecSent[NSent]=sDireita;
		NSent++;
	}
	if (pLabirinto->GetPosicao(POS(Posicao.x-1,Posicao.y))!=PAREDE)
	{
		VecSent[NSent]=sEsquerda;
		NSent++;
	}
	if (pLabirinto->GetPosicao(POS(Posicao.x,Posicao.y-1))!=PAREDE)
	{
		VecSent[NSent]=sCima;
		NSent++;
	}
	if (pLabirinto->GetPosicao(POS(Posicao.x,Posicao.y+1))!=PAREDE)
	{
		VecSent[NSent]=sBaixo;
		NSent++;
	}
	if (NSent>2 || proximo == PAREDE) //tem bifurcao
		SentidoAtual=VecSent[rand()%NSent];
	
	pSecaoCritica->Lock();
	// Como durante a longa deciso acima ou durante a espera
	// para entrar na seo crtica, este boot pode ter morrido,
	// faz-se o testizinho novamente para no gerar um zumbi.
	// O teste do Status e a ao efetiva  feita atomicamente,
	// a deciso acima no requer a seo crtica, pois 
	// nenhuma ao  feita, apenas a preparao da mesma.
		
		if(GetStatus()!=sMorto)
		{
			Move(SentidoAtual);
			if ((p = pLabirinto->GetJogador(Posicao)) != NULL)
			{
				StatusDoJogador = p->GetStatus();
				if (StatusDoJogador != sMorto)
				{
					if (StatusDoJogador==sAnormal && Status == sAnormal)
						Status = sMorto;
					else 
						p->MorreDesgracado();
				}
			}
		}
	pSecaoCritica->Unlock();
}
pLabirinto->RemoveBoot(this); //morte do boot
_endthreadex((DWORD) 0); //morte da thread do boot
}
//---------------------------------------------------------------------------//