/******************************************************************************
 *   JANELAPRINCIPAL.CPP                                                      *
 ******************************************************************************		
 *                                                                            *
 * Arquivo contendo a declarao da interface com o usurio, como menus,      *
 * janela principal, teclado etc                                              *
 *                                                                            *
 ******************************************************************************
 *                                                                            * 
 *    Trabalho Prtico de Automao em Tempo Real                             *
 *       6 Perodo de Engenharia de Controle e Automao                     *
 *           Universidade Federal de Minas Gerais                             *
 *                                                                            *
 *    Prof.:  Constantino Seixas Filho                                        *
 *                                                                            *
 *    Alunos: Rafael Cervolo                                                 *
 *            Thiago Barbosa                                                  *
 *                                                                            *
 *****************************************************************************/

#include "JanelaPrincipal.h"
//#include "resources.h"
#include "intro.h"
#include "Classes.h"
#include "Mapas.h"

TMatriz Fases[10] = {FASE1,FASE2,FASE3,FASE4,FASE5,FASE6,FASE7,FASE8,FASE9,FASE10};



BEGIN_MESSAGE_MAP(CJanelaPrincipal, CFrameWnd)
  ON_WM_KEYDOWN()
  ON_WM_CHAR()
  ON_COMMAND(IDM_NOVO, CJanelaPrincipal::OnNovo)
  ON_COMMAND(IDM_SAIR, CJanelaPrincipal::OnSair)
  ON_COMMAND(IDM_ATR, CJanelaPrincipal::OnSkinAtr)
  ON_COMMAND(IDM_GUGIX, CJanelaPrincipal::OnSkinGugix)
  ON_COMMAND(IDM_CLASSICO, CJanelaPrincipal::OnSkinClassico)
  ON_COMMAND(IDM_FASE1, CJanelaPrincipal::OnFase1)
  ON_COMMAND(IDM_FASE2, CJanelaPrincipal::OnFase2)
  ON_COMMAND(IDM_FASE3, CJanelaPrincipal::OnFase3)
  ON_COMMAND(IDM_FASE4, CJanelaPrincipal::OnFase4)
  ON_COMMAND(IDM_FASE5, CJanelaPrincipal::OnFase5)
  ON_COMMAND(IDM_FASE6, CJanelaPrincipal::OnFase6)  
  ON_COMMAND(IDM_FASE7, CJanelaPrincipal::OnFase7)
  ON_COMMAND(IDM_FASE8, CJanelaPrincipal::OnFase8)  
  ON_COMMAND(IDM_FASE9, CJanelaPrincipal::OnFase9)
  ON_COMMAND(IDM_FASE10, CJanelaPrincipal::OnFase10)
  ON_COMMAND(IDM_DIFICULDADE1, CJanelaPrincipal::OnDificuldade1)
  ON_COMMAND(IDM_DIFICULDADE2, CJanelaPrincipal::OnDificuldade2)
  ON_COMMAND(IDM_DIFICULDADE3, CJanelaPrincipal::OnDificuldade3)
  ON_COMMAND(IDM_DIFICULDADE4, CJanelaPrincipal::OnDificuldade4)
  ON_COMMAND(IDM_DIFICULDADE5, CJanelaPrincipal::OnDificuldade5)
  ON_COMMAND(IDM_DIFICULDADE6, CJanelaPrincipal::OnDificuldade6)
END_MESSAGE_MAP()
//---------------------------------------------------------------------------//
//Globalzonas
int FaseAtual=1;

CLabirinto Labirinto; //O Labirinto
CHandle hInimigos, hJogadores; //Classe controladora das handles dos personagens
HANDLE hRefrescaTela; HANDLE hIntro; // Handles das threads grdicas
int Dificuldade=4; //Nvel de dificuldade do jogo (global por enquanto)
//---------------------------------------------------------------------------//
DWORD WINAPI RefrescaTela()
{
/* Funo para atualizar em pequenos intervalos de tempo o desenho do labirinto
   e seus respectivos personagens.
   A utilizao desta funo facilita a programao do restante do programa,
   que no se preocupa de quando nem onde desenhar o qu
*/
CWnd *pWnd=AfxGetMainWnd();
CDC *pDC=pWnd->GetDC();
int i=0;
CString texto;
time_t Tempo0,TempoAtual; //Registradores de tempo
time(&Tempo0); //Pega o tempo de incio do Jogo (considerado quando o usurio
			   // enxerga pela primeira vez o desenho do labirinto)
CJogador *pJ1,*pJ2; //Apontadores para os dois possveis jogadores
CString Texto1, Texto2,aux; //Variveis de texto auxiliares
bool Pisca=false; //Comutador do pisca-pisca dos textos
int k=0; // contador de quadros, usado na comutao de "Pisca"
pDC->FillSolidRect(0,0,800,600,RGB(255,255,255)); //Limpa a tela sujada pela
                                                  //introduo
while(1)
{
	// A sequencia abaixo escreve as informaes textuais no painel
	Texto1 = ""; //Zera variveis
	Texto2 = "";
	Labirinto.DesenhaLabirinto(pDC);
	pJ1 = Labirinto.GetJogador(0);
	pJ2 = Labirinto.GetJogador(1);
	pDC->TextOut(570,30,"JOGADOR 1");
	pDC->TextOut(570,155,"JOGADOR 2");
	pDC->TextOut(570,275,"JOGO");

	if (pJ1 == NULL)
	{
		if (Pisca)
		{
			pDC->TextOut(590,50,"Pressione F1              ");
			pDC->TextOut(590,70,"                                    ");
			pDC->TextOut(590,90,"                                    ");
		}
		else
		{
			pDC->TextOut(580,50,"                                 ");
			pDC->TextOut(580,70,"                                  ");
			pDC->TextOut(580,90,"                                  ");
		}
	}
	else
	{		
		
		aux.Format("Vidas: %d              ",pJ1->GetVidas());
		pDC->TextOut(580,50,aux);
		aux.Format("Inimigos Mortos: %d        ",pJ1->GetInimigosMortos());
		pDC->TextOut(580,70,aux);
		aux.Format("Pontos: %d             ",pJ1->GetPontos());
		pDC->TextOut(580,90,aux);
	}
	if (pJ2 == NULL)
	{
		if (Pisca)
		{
			pDC->TextOut(590,175,"Pressione F2              ");
			pDC->TextOut(590,195,"                               ");
			pDC->TextOut(590,215,"                              ");
		}
		else
		{
			pDC->TextOut(580,175,"                                 ");
			pDC->TextOut(580,195,"                                  ");
			pDC->TextOut(580,215,"                                  ");
		}
	}
	else
	{
		aux.Format("Vidas: %d              ",pJ2->GetVidas());
		pDC->TextOut(580,175,aux);
		aux.Format("Inimigos Mortos: %d        ",pJ2->GetInimigosMortos());
		pDC->TextOut(580,195,aux);
		aux.Format("Pontos: %d             ",pJ2->GetPontos());
		pDC->TextOut(580,215,aux);
	}
		aux.Format("Fase Atual: %d              ",2);
		pDC->TextOut(580,295,aux);
		aux.Format("Bolas: %d        ",Labirinto.GetTotalDeBolas());
		pDC->TextOut(580,315,aux);
		time(&TempoAtual);
		TempoAtual-= Tempo0;
		aux.Format("Tempo: %2d:%2.2d",TempoAtual/60,TempoAtual%60);
		pDC->TextOut(580,335,aux);
k++;
	// E o trecho abaixo desenha as linhas em volta dos textos.
	if (k>10) 
	{
		k=0;
		Pisca = !Pisca;
		//Frame do PLacar do Jogador 1
		pDC->MoveTo(560,20);
		pDC->LineTo(760,20);		pDC->LineTo(760,120);
		pDC->LineTo(560,120);		pDC->LineTo(560,20);
		
		pDC->MoveTo(555,15);
		pDC->LineTo(765,15);		pDC->LineTo(765,125);
		pDC->LineTo(555,125);		pDC->LineTo(555,15);

		//Frame do Placar do Jogador 2
		pDC->MoveTo(560,145);
		pDC->LineTo(760,145);		pDC->LineTo(760,245);
		pDC->LineTo(560,245);		pDC->LineTo(560,145);
		
		pDC->MoveTo(555,140);
		pDC->LineTo(765,140);		pDC->LineTo(765,250);
		pDC->LineTo(555,250);		pDC->LineTo(555,140);
		
		// Frame do Placar do Jogo
		pDC->MoveTo(560,270);
		pDC->LineTo(760,270);		pDC->LineTo(760,370);
		pDC->LineTo(560,370);		pDC->LineTo(560,270);
		
		pDC->MoveTo(555,265);
		pDC->LineTo(765,265);		pDC->LineTo(765,375);
		pDC->LineTo(555,375);		pDC->LineTo(555,265);
	}
	Sleep(1000/15);
}
pWnd->ReleaseDC(pDC);
return 0;
}
//---------------------------------------------------------------------------//
CJanelaPrincipal::CJanelaPrincipal()
{
Create(NULL,
           "SSS Sedan",
           WS_OVERLAPPEDWINDOW &~WS_THICKFRAME, //sem resizing
           CRect(0,0,(LARGURA+1)*COLUNAS+(BORDA_ESQUERDA+BORDA_DIREITA)
		   ,(ALTURA+1)*LINHAS+(BORDA_SUPERIOR+BORDA_INFERIOR)+40)
		   ,NULL,MAKEINTRESOURCE(IDM_MENU));
	
	TMatriz aux = FASE1;
	Labirinto.CarregaLabirinto(aux);
	Labirinto.SetPHandles(&hJogadores,&hInimigos);
	OnSkinGugix(); // Skin inicial aqui.
	CenterWindow();
	LoadAccelTable(MAKEINTRESOURCE(IDA_TECLAS_DE_ATALHO));
	hIntro = IniciaIntro();
};
//---------------------------------------------------------------------------//
CJanelaPrincipal::~CJanelaPrincipal()
// Destrutor da janela principal.
// Como  o fim do programa mesmo, fecha os Handles remanescentes
{
CloseHandle(hIntro);
CloseHandle(hRefrescaTela);
}
//---------------------------------------------------------------------------//
void CJanelaPrincipal::OnKeyDown(UINT nChar, UINT nRep, UINT nFlags)
{
// Resposta ao teclado:
static PrimeiraTeclada = true;

//Testa o estado das setas
TSentido Sentido = sNenhum;
TSentido Sentido1 = sNenhum;
if (GetKeyState(VK_LEFT)<0)
	Labirinto.Tecla(VK_LEFT);	
else if (GetKeyState(VK_RIGHT)<0)
	Labirinto.Tecla(VK_RIGHT);	
else if(GetKeyState(VK_UP)<0)
	Labirinto.Tecla(VK_UP);	
else if (GetKeyState(VK_DOWN)<0)
	Labirinto.Tecla(VK_DOWN);
if (GetKeyState(VK_NUMPAD4)<0)
	Labirinto.Tecla(VK_NUMPAD4);
else if (GetKeyState(VK_NUMPAD6)<0)
	Labirinto.Tecla(VK_NUMPAD6);
else if(GetKeyState(VK_NUMPAD8)<0)
	Labirinto.Tecla(VK_NUMPAD8);
else if (GetKeyState(VK_NUMPAD2)<0)
	Labirinto.Tecla(VK_NUMPAD2);

TSkinPersonagem Skin; //Pele para passar para os personagens
TTeclado Teclado; //Mapa do teclado para passar para os jogadores
DWORD Ret; //Retorno de criao de threads
CJogador *pJ; 
if (PrimeiraTeclada) //Se nunca encostou no teclado,
{
	if (nChar == VK_F1 || nChar == VK_F2) // e foi F1 ou F2,
	{
		InterrompeIntro(); //Para introduo
		Ret = WaitForSingleObject(hIntro,INFINITE); //e espera ela terminar
		PrimeiraTeclada = false;
		DWORD ID;
		Skin = Labirinto.GetSkinHeroi();
		// Para comear a exibir o jogo, cria-se a thread de atualizao 
		hRefrescaTela = (HANDLE)_beginthreadex(NULL,0,(CAST_FUNCTION)RefrescaTela,
	             NULL,0,(CAST_LPDWORD)&ID);
		if (nChar == VK_F1)
		{
			// Inicia jogador 1
			Teclado.Cima = VK_UP;			Teclado.Baixo = VK_DOWN;
			Teclado.Esquerda = VK_LEFT;		Teclado.Direita = VK_RIGHT;
			Skin = Labirinto.GetSkinHeroi();
			if (Labirinto.AdicionaJogador(Skin,Teclado,0))
			{
				CriaThreadJogador(Labirinto.Jogadores[0],&hJogadores);
			}
		}
		else
		{
			// Inicia jogador 2
			Teclado.Cima = VK_NUMPAD8;		Teclado.Baixo = VK_NUMPAD2;
			Teclado.Esquerda = VK_NUMPAD4;	Teclado.Direita = VK_NUMPAD6;	
			if (Labirinto.AdicionaJogador(Skin,Teclado,1))
				CriaThreadJogador(Labirinto.Jogadores[1],&hJogadores);
		}
		PassaDificuldade(4); //Dificuldade inicial pe-se aqui.	
	}
}
// Aqui o jogo j est em execuo, portatno o tratamento das teclas e diferente
else if(nChar == VK_F1) 
{
	// Se apertou F1 adiciona-se o Jogador 1, caso este no exista.
	pJ = Labirinto.GetJogador(0);
	if (pJ == NULL)
	{
		Teclado.Cima = VK_UP;			Teclado.Baixo = VK_DOWN;
		Teclado.Esquerda = VK_LEFT;		Teclado.Direita = VK_RIGHT;
		Skin = Labirinto.GetSkinHeroi();
		if (Labirinto.AdicionaJogador(Skin,Teclado,0))
		{
			CriaThreadJogador(Labirinto.Jogadores[0],&hJogadores);
		}	
	}
}
else if (nChar == VK_F2)
{
	// O mesmo com o jogador 2
	pJ = Labirinto.GetJogador(1);
	if (pJ == NULL)
	{
		Teclado.Cima = VK_NUMPAD8;		Teclado.Baixo = VK_NUMPAD2;
		Teclado.Esquerda = VK_NUMPAD4;	Teclado.Direita = VK_NUMPAD6;	
		Skin = Labirinto.GetSkinHeroi();
		if (Labirinto.AdicionaJogador(Skin,Teclado,1))
		{
			CriaThreadJogador(Labirinto.Jogadores[1],&hJogadores);
		}	
	}
}
else if (nChar == VK_ESCAPE)
	InterrompeIntro();
}
//---------------------------------------------------------------------------//
void CJanelaPrincipal::OnSkinAtr()
{
// O usurio clicou no menu Opes->Skin->ATR
TSkinLabirinto Lab;
TSkinPersonagem Heroi;
TSkinPersonagem Inimigo;
Lab.Bola = ATR_BOLA;
Lab.Parede = ATR_PAREDE;
Lab.Poder = ATR_PODER;
Lab.Vao = ATR_VAO;
Heroi.AnormalA = ATR_HEROI2A;
Heroi.AnormalB = ATR_HEROI2B;
Heroi.NormalA = ATR_HEROI1A;
Heroi.NormalB = ATR_HEROI1B;
Inimigo.AnormalA = ATR_INIMIGO2A;
Inimigo.AnormalB = ATR_INIMIGO2B;
Inimigo.NormalA = ATR_INIMIGO1A;
Inimigo.NormalB = ATR_INIMIGO1B;
Labirinto.CarregaBitmaps(Lab,Heroi,Inimigo);	
}
//---------------------------------------------------------------------------//
void CJanelaPrincipal::OnSkinGugix()
{
// O usurio clicou no menu Opes->Skin->Gugix
TSkinLabirinto Lab;
TSkinPersonagem Heroi;
TSkinPersonagem Inimigo;
Lab.Bola = GUGA_BOLA;
Lab.Parede = GUGA_PAREDE;
Lab.Poder = GUGA_PODER;
Lab.Vao = GUGA_VAO;
Heroi.AnormalA = GUGA_HEROI2A;
Heroi.AnormalB = GUGA_HEROI2B;
Heroi.NormalA = GUGA_HEROI1A;
Heroi.NormalB = GUGA_HEROI1B;
Inimigo.AnormalA = GUGA_INIMIGO2A;
Inimigo.AnormalB = GUGA_INIMIGO2B;
Inimigo.NormalA = GUGA_INIMIGO1A;
Inimigo.NormalB = GUGA_INIMIGO1B;
Labirinto.CarregaBitmaps(Lab,Heroi,Inimigo);	
}
//---------------------------------------------------------------------------//
void CJanelaPrincipal::OnSkinClassico()
{
// O usurio clicou no menu Opes->Skin->Classico
TSkinLabirinto Lab;
TSkinPersonagem Heroi;
TSkinPersonagem Inimigo;
Lab.Bola = PAC_BOLA;
Lab.Parede = PAC_PAREDE;
Lab.Poder = PAC_PODER;
Lab.Vao = PAC_VAO;
Heroi.AnormalA = PAC_HEROI2A;
Heroi.AnormalB = PAC_HEROI2B;
Heroi.NormalA = PAC_HEROI1A;
Heroi.NormalB = PAC_HEROI1B;
Inimigo.AnormalA = PAC_INIMIGO2A;
Inimigo.AnormalB = PAC_INIMIGO2B;
Inimigo.NormalA = PAC_INIMIGO1A;
Inimigo.NormalB = PAC_INIMIGO1B;
Labirinto.CarregaBitmaps(Lab,Heroi,Inimigo);	
}
//---------------------------------------------------------------------------//
// A troca de fase  outra coisa que no ficou boa neste programa,
// mas como engenharia  entregar o que pode dentro do prazo, ficou assim mesmo
// As fases esto definidas no arquivo "Mapas.h"
// A atribuio  feita na raa quando se inicia a varivel matricial.
//
// As funes abaixo so a resposta aos menus Opes->Fase->FaseN
void AvancaFase()
{
FaseAtual = 1+(FaseAtual)%10;
PassaFase(FaseAtual);
}

void CJanelaPrincipal::OnFase1()
{
	PassaFase(1);
}
void CJanelaPrincipal::OnFase2()
{
	PassaFase(2);
}
void CJanelaPrincipal::OnFase3()
{
	PassaFase(3);
}
void CJanelaPrincipal::OnFase4()
{
	PassaFase(4);
}
void CJanelaPrincipal::OnFase5()
{
	PassaFase(5);
}
void CJanelaPrincipal::OnFase6()
{
	PassaFase(6);
}
void CJanelaPrincipal::OnFase7()
{
	PassaFase(7);
}
void CJanelaPrincipal::OnFase8()
{
	PassaFase(8);
}
void CJanelaPrincipal::OnFase9()
{
	PassaFase(9);
}
void CJanelaPrincipal::OnFase10()
{
	PassaFase(10);
}
//---------------------------------------------------------------------------//
void PassaDificuldade(int N)
// A dificuldade modifica a velocidade do jogo e o nmero de inimigos
{
int in,Ti,Tj,i;
Labirinto.ChacinaInimigos();
Labirinto.RecolheJogadores();
for (i=0;i<N+1;i++)
{
	Sleep(55); // Gerar um atrazinho entre as entradas dos inimigos
	if ((in = Labirinto.AdicionaInimigo(Labirinto.GetSkinInimigo()))>-1);
	CriaThreadInimigo(Labirinto.Inimigos[in],&hInimigos);
}
Ti = 650-N*100; //Relao razovel para os nveis de dificuldades
Tj = 600-N*100;
if (Ti <=0) Ti = 10; //valores mnimos para os tempos
if (Tj <=0) Tj = 10;
	Labirinto.SetTempos(Ti,Tj);
}
//---------------------------------------------------------------------------//
void PassaFase(int F)
{
// Aps a matriz "m" ter sido iniciada, utili-ze esta funo para reiniciar
// o jogo com a nova fase.
FaseAtual = F;
Labirinto.ChacinaInimigos();
Labirinto.RecolheJogadores();
Labirinto.CarregaLabirinto(Fases[F-1]);
PassaDificuldade(Dificuldade);
}
//---------------------------------------------------------------------------//
// Funes abaixo so do menu Opes->Dificuldade->DificuldadeN
void CJanelaPrincipal::OnDificuldade1()
{
	PassaDificuldade(1); // Inicia a fase
	Dificuldade = 1; //Atualiza a variavel global
}
void CJanelaPrincipal::OnDificuldade2()
{
	PassaDificuldade(2);	
	Dificuldade = 2;
}
void CJanelaPrincipal::OnDificuldade3()
{
	PassaDificuldade(3);
	Dificuldade = 3;
}
void CJanelaPrincipal::OnDificuldade4()
{
	PassaDificuldade(4);
	Dificuldade = 4;
}
void CJanelaPrincipal::OnDificuldade5()
{
	PassaDificuldade(5);
	Dificuldade = 5;
}
void CJanelaPrincipal::OnDificuldade6()
{
	PassaDificuldade(50);
	Dificuldade = 50;
}
//---------------------------------------------------------------------------//
void CJanelaPrincipal::OnSair()
{
//Usurio clicou em Arquivo->Sair
	ExitProcess(1); // No tinha o MSDN 100% instalado e portanto no
	// encontrei a tabela com os valores correspondentes as saidas de processo
}
//---------------------------------------------------------------------------//
void CJanelaPrincipal::OnNovo()
{
//Usurio clicou em Arquivo->Novo
OnFase1();
PassaDificuldade(Dificuldade);
}
//---------------------------------------------------------------------------//

