/******************************************************************************
 *   INTRO.CPP                                                                *
 ******************************************************************************		
 *                                                                            *
 * Arquivo contendo a animao de introduo do jogo                          *
 *                                                                            *
 * O algortimo  bem ruim, mas como s roda uma vez e foi feito as           *
 * pressas,  aceitvel                                                       *
 ******************************************************************************
 *                                                                            * 
 *    Trabalho Prtico de Automao em Tempo Real                             *
 *       6 Perodo de Engenharia de Controle e Automao                     *
 *           Universidade Federal de Minas Gerais                             *
 *                                                                            *
 *    Prof.:  Constantino Seixas Filho                                        *
 *                                                                            *
 *    Alunos: Rafael Cervolo                                                 *
 *            Thiago Barbosa                                                  *
 *                                                                            *
 *****************************************************************************/

#include "classes.h"
#include "intro.h"
//---------------------------------------------------------------------------//
bool TerminaAnime; // Global Sem Vergonha para finalizar a animao
HANDLE IniciaIntro()
{
DWORD lixo;
HANDLE hRet;
hRet = (HANDLE)_beginthreadex(NULL,0,(CAST_FUNCTION)AnimaIntro,
							  NULL,0,(CAST_LPDWORD)&lixo);
return (hRet);
}
//---------------------------------------------------------------------------//
void InterrompeIntro()
{
	TerminaAnime = true;
}
//---------------------------------------------------------------------------//
/* 
	 As posies dos bitmaps, das animaes e etc esto fortemente baseados
  em valores absolutos de pixels da janela.
  Portanto, se modificar o tamanho inicial da janela, ficar bagunada a
  animao na tela.
     Em resumo, fica um loop com um Sleep dentro dele para mudar os quadros da
  animao.
	 A cada loop, testa-se o nmero da iterao para saber o que deve ser desenhado.
  Aps todos os quadros terem terminado, ou se a varivel global "TerminaAnime"
  ficar falsa, a thread da introduo termina.
     O teste da varivel "TerminaAnime" no  feita em excluso mtua, pois para 
  fins prricos  desnecessrio, pois esta varivel muda de valor apenas uma
  vez, e s em uma direo (a janela principal valida e a thread testa) 
*/
DWORD WINAPI AnimaIntro(CDC* pDC2)
{
CWnd *pWnd=AfxGetMainWnd();
CDC *pDC=pWnd->GetDC();
CBitmap Pac1,Pac2,Logo1,Logo2,Logo3,Fantasma1,Fantasma2;
CDC dcPac1,dcPac2,dcLogo1,dcLogo2,dcLogo3;

Pac1.LoadBitmap(INTRO_PAC1);
Pac2.LoadBitmap(INTRO_PAC2);
Logo1.LoadBitmap(INTRO_LOGO1);
Logo2.LoadBitmap(INTRO_LOGO2);
Logo3.LoadBitmap(INTRO_LOGO3);
Fantasma1.LoadBitmap(INTRO_FANTASMA1);
Fantasma2.LoadBitmap(INTRO_FANTASMA2);
dcPac1.CreateCompatibleDC(pDC);
dcPac2.CreateCompatibleDC(pDC);
dcLogo1.CreateCompatibleDC(pDC);
dcLogo2.CreateCompatibleDC(pDC);
dcLogo3.CreateCompatibleDC(pDC);
dcPac1.SelectObject(&Pac1);
dcPac2.SelectObject(&Pac2);
dcLogo1.SelectObject(&Logo1);
dcLogo2.SelectObject(&Logo2);
dcLogo3.SelectObject(&Logo3);
int i, esq,cima,baixo,dir,largura,altura;
CBrush Brush;
pDC->FillSolidRect(0,0,800,600,RGB(0,0,0));
bool troca=false,mod;
int j=0,k=0;
while(j<250 && !TerminaAnime)
{
	j++;
	cima = BORDA_SUPERIOR;
	baixo = ((ALTURA+1)*(LINHAS-1));
	Sleep(1000/30); //30 quadros/segundo
	if (j%5==0 && j>0 && j<220)
	{
		troca = !troca;
		for (i=0;i<9;i++)
		{
			esq = BORDA + i*((LARGURA+1)*(COLUNAS-1)-BORDA)/8+60;
			mod = i%2 == 0;
			if (troca ^ mod)
			{
				pDC->DrawState(CPoint(esq,cima),CSize(32,32),&Fantasma1,
					DST_BITMAP,NULL);
				pDC->DrawState(CPoint(esq,baixo),CSize(32,32),&Fantasma2,
					DST_BITMAP,NULL);
			}	
			else
			{
				pDC->DrawState(CPoint(esq,cima),CSize(32,32),
					&Fantasma2,DST_BITMAP,NULL);
				pDC->DrawState(CPoint(esq,baixo),CSize(32,32),
					&Fantasma1,DST_BITMAP,NULL);
			}
		}
		esq = BORDA;
		dir = BORDA+(LARGURA+1)*(COLUNAS-1);
		for (i=0;i<8;i++)
		{
			cima = BORDA_SUPERIOR + i*((ALTURA+1)*(LINHAS-1)-BORDA_SUPERIOR)/7;
			mod = i%2 == 0;
			if (troca ^ mod)
			{
				pDC->DrawState(CPoint(esq,cima),CSize(32,32),
					&Fantasma1,DST_BITMAP,NULL);
				pDC->DrawState(CPoint(dir,cima),CSize(32,32),
					&Fantasma2,DST_BITMAP,NULL);
			}
			else
			{
				pDC->DrawState(CPoint(esq,cima),CSize(32,32),
					&Fantasma2,DST_BITMAP,NULL);
				pDC->DrawState(CPoint(dir,cima),CSize(32,32),
					&Fantasma1,DST_BITMAP,NULL);
			}
		}
	}
	if (j<16)
	{
		k++;
		largura = 344/15*k;
		altura = 110/15*k;
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcLogo1,0,0,344,110,SRCCOPY);
	}
	else if (j>60 && j<76)
	{
		k--;
		largura = 344/15*k;
		altura = 110/15*k;
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcLogo1,0,0,344,110,SRCCOPY);
	}
	else if (j>76 && j<91)
	{
		k++;
		largura = 2*184/15*k;
		altura = 2*k;
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcLogo2,0,0,184,17,SRCCOPY);
	}
	else if (j>110 && j<126)
	{
		k--;
		largura = 2*184/15*k;
		altura = 2*k;
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcLogo2,0,0,184,17,SRCCOPY);
	}
	else if (j>126 && j<142)
	{
		k++;
		largura = 450/15*k;
		altura = 400/15*k;
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcLogo3,0,0,248,100,SRCCOPY);
	}
	else if (j>170 && j<186)
	{
		k--;
		largura = 450/15*k;
		altura = 400/15*k;
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcLogo3,0,0,248,100,SRCCOPY);
	}
	else if (j> 220 && j< 250)
	{
		k++;
		largura = 600/30*k;
		altura = 600/30*k;
		if (j%2)
		pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcPac2,0,0,32,32,SRCCOPY);
		else
			pDC->StretchBlt((794-largura)/2,(532-altura)/2,largura,altura,
			              &dcPac1,0,0,32,32,SRCCOPY);

	}

}
pDC->SetBkColor(RGB(255,255,0));
pDC->TextOut(305,370,"JOGADOR 1 : Pressione F1");
pDC->TextOut(305,400,"JOGADOR 2 : Pressione F2");

TerminaAnime = false;
pWnd->ReleaseDC(pDC);
_endthreadex((DWORD) 0);
return (0);
}